(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define('ngx-loader-indicator', ['exports', '@angular/core', '@angular/common'], factory) :
	(factory((global['ngx-loader-indicator'] = {}),global.ng.core,global.ng.common));
}(this, (function (exports,core,common) { 'use strict';

var config = new core.InjectionToken('config');
var NEW_CONFIG = new core.InjectionToken('NEW_CONFIG');
var INITIAL_CONFIG = new core.InjectionToken('INITIAL_CONFIG');
var initialConfig = {
    img: '/assets/images/spinner.svg',
    loaderStyles: {
        'position': 'absolute',
        'left': '0',
        'right': '0',
        'top': '0',
        'bottom': '0',
        'background': 'rgba(255, 255, 255, 0.8)',
        'z-index': '50',
    },
    imgStyles: {
        'position': 'absolute',
        'top': '50%',
        'left': '50%',
        'transform': 'translate(-50%, -50%)',
        'max-width': '20px',
        'max-height': '20px',
    },
    hostStyles: {
        'position': 'relative'
    }
};
var AngularLoaderDirective = /** @class */ (function () {
    function AngularLoaderDirective(_config, _el, _renderer) {
        this._config = _config;
        this._el = _el;
        this._renderer = _renderer;
        this.loaderStyles = _config.loaderStyles;
        this.imgStyles = _config.imgStyles;
        this.hostStyles = _config.hostStyles;
        this.img = _config.img;
    }
    Object.defineProperty(AngularLoaderDirective.prototype, "show", {
        set: function (value) {
            if (!value) {
                this.loaderEl ? this._setStyles(this.loaderEl, { display: 'none' }) : null;
                return;
            }
            this.loaderEl = this._renderer.createElement('div');
            var img = this._renderer.createElement('img');
            this._renderer.appendChild(this._el.nativeElement, this.loaderEl);
            this._renderer.appendChild(this.loaderEl, img);
            this._setStyles(this._el.nativeElement, this.hostStyles);
            this._setStyles(this.loaderEl, this.loaderStyles);
            this._setStyles(img, this.imgStyles);
            this._renderer.setAttribute(img, 'src', this.img);
        },
        enumerable: true,
        configurable: true
    });
    AngularLoaderDirective.prototype._setStyles = function (element, styles) {
        var _this = this;
        Object.keys(styles).forEach(function (key) {
            _this._renderer.setStyle(element, key, styles[key]);
        });
    };
    return AngularLoaderDirective;
}());
AngularLoaderDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[loader]',
            },] },
];
AngularLoaderDirective.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [config,] },] },
    { type: core.ElementRef, },
    { type: core.Renderer2, },
]; };
AngularLoaderDirective.propDecorators = {
    "show": [{ type: core.Input },],
};
var NgxLoaderIndicatorModule = /** @class */ (function () {
    function NgxLoaderIndicatorModule() {
    }
    NgxLoaderIndicatorModule.forRoot = function (configValue) {
        return {
            ngModule: NgxLoaderIndicatorModule,
            providers: [
                {
                    provide: NEW_CONFIG,
                    useValue: configValue
                },
                {
                    provide: INITIAL_CONFIG,
                    useValue: initialConfig
                },
                {
                    provide: config,
                    useFactory: _configFactory,
                    deps: [INITIAL_CONFIG, NEW_CONFIG]
                },
            ]
        };
    };
    return NgxLoaderIndicatorModule;
}());
NgxLoaderIndicatorModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    AngularLoaderDirective,
                ],
                exports: [
                    AngularLoaderDirective,
                ]
            },] },
];
function _configFactory(initConfig, configValue) {
    return (typeof configValue === 'function') ? configValue() : Object.assign({}, initConfig, configValue);
}

exports.config = config;
exports.NEW_CONFIG = NEW_CONFIG;
exports.INITIAL_CONFIG = INITIAL_CONFIG;
exports.initialConfig = initialConfig;
exports.NgxLoaderIndicatorModule = NgxLoaderIndicatorModule;
exports._configFactory = _configFactory;
exports.AngularLoaderDirective = AngularLoaderDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-loader-indicator.umd.js.map
